package implement

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/dao"
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/models"
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/utils/logx"
	"xorm.io/xorm"
)

type HappyOrchardUserSeedRecordDb struct {
	Db *xorm.Engine
}

func (h HappyOrchardUserSeedRecordDb) UpdateHappyOrchardUserSeedRecord(m *models.HappyOrchardUserSeedRecord, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = h.Db.Where("id=?", m.Id).Cols(forceColums...).Update(m)
	} else {
		affected, err = h.Db.Where("id=?", m.Id).Update(m)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func NewHappyOrchardUserSeedRecordDb(engine *xorm.Engine) dao.HappyOrchardUserSeedRecordDao {
	return &HappyOrchardUserSeedRecordDb{Db: engine}
}

func (h HappyOrchardUserSeedRecordDb) GetHappyOrchardUserSeedRecord(id int) (m *models.HappyOrchardUserSeedRecord, err error) {
	//TODO implement me
	m = new(models.HappyOrchardUserSeedRecord)
	has, err := h.Db.Where("id =?", id).Get(m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (h HappyOrchardUserSeedRecordDb) FindHappyOrchardUserSeedRecordByUid(uid int) (mm *[]models.HappyOrchardUserSeedRecord, err error) {
	//TODO implement me
	var m []models.HappyOrchardUserSeedRecord
	if err := h.Db.Where("uid =?", uid).Desc("id").Find(&m); err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	return &m, nil
}
func (h HappyOrchardUserSeedRecordDb) GetHappyOrchardUserSeedRecordByUidWithState(uid, state int) (m *models.HappyOrchardUserSeedRecord, err error) {
	m = new(models.HappyOrchardUserSeedRecord)
	has, err := h.Db.Where("uid =? and state=?", uid, state).Get(m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}
func (h HappyOrchardUserSeedRecordDb) GetHappyOrchardUserSeedRecordByUidWithStateAndId(uid, id, state int) (m *models.HappyOrchardUserSeedRecord, err error) {
	m = new(models.HappyOrchardUserSeedRecord)
	has, err := h.Db.Where("uid =? and state=? and id=?", uid, state, id).Get(m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}
func (h HappyOrchardUserSeedRecordDb) FindHappyOrchardUserSeedRecordAll(uid, start, limit int) (mm *[]models.HappyOrchardUserSeedRecord, err error) {
	var m []models.HappyOrchardUserSeedRecord
	if err := h.Db.Where("uid=?", uid).OrderBy("id desc").Limit(limit, start).Find(&m); err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	return &m, nil
}
